// Stopwatch.h : Declaration of the CStopwatch

#pragma once
#include "resource.h"       // main symbols
#include <Winbase.h>
#include "Stopwatch_srv_i.h"


#if defined(_WIN32_WCE) && !defined(_CE_DCOM) && !defined(_CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA)
#error "Single-threaded COM objects are not properly supported on Windows CE platform, such as the Windows Mobile platforms that do not include full DCOM support. Define _CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA to force ATL to support creating single-thread COM object's and allow use of it's single-threaded COM object implementations. The threading model in your rgs file was set to 'Free' as that is the only threading model supported in non DCOM Windows CE platforms."
#endif



// CStopwatch

class ATL_NO_VTABLE CStopwatch :
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CStopwatch, &CLSID_Stopwatch>,
	public ISupportErrorInfo,
	public IStopwatch
{
	LARGE_INTEGER m_nFrequency;
	LARGE_INTEGER m_nStartTime;
	float m_Overhead;
public:
	CStopwatch()
	{
		m_Overhead=0.0;
		  m_nStartTime.QuadPart = 0;

		// Save the frequency of the performance counters
		QueryPerformanceFrequency ((LARGE_INTEGER*) &m_nFrequency);

	}

DECLARE_REGISTRY_RESOURCEID(IDR_STOPWATCH)


BEGIN_COM_MAP(CStopwatch)
	COM_INTERFACE_ENTRY(IStopwatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
END_COM_MAP()

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);


	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}

	void FinalRelease()
	{
	}

public:

	STDMETHOD(Start)(void);
	STDMETHOD(ElapsedTime)(FLOAT* Time);
	STDMETHOD(get_Overhead)(FLOAT* pVal);
	STDMETHOD(put_Overhead)(FLOAT newVal);
	STDMETHOD(Add)(FLOAT a, FLOAT b, FLOAT* out);
	STDMETHOD(Div)(FLOAT a, FLOAT b, FLOAT* out);
};

OBJECT_ENTRY_AUTO(__uuidof(Stopwatch), CStopwatch)
